/*Copyright (c) 2012 Moussa Dembélé (www.mousman.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package com.mousman.as3.agal.mesh 
{
	import com.mousman.as3.agal.light.IMLight;
	import flash.display3D.Context3D;
	import flash.display3D.VertexBuffer3D;
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;
	
	/**
	 * ...
	 * @author Moussa Dembélé (www.mousman.com)
	 */
	public interface IMMesh 
	{
		function setVertexBufferAt(index:int, vertexBuffer:VertexBuffer3D, bufferOffset:int, format:String):void;
		function drawTriangles():void;
		function get modelMatrix():Matrix3D;
		function set modelMatrix(value:Matrix3D):void;
		function get context3D():Context3D;
		function set context3D(value:Context3D):void;
		function setProgramConstantsFromMatrix(type:String, firstRegister:int, matrix:Matrix3D, transposedMatrix:Boolean = false):void;
		function setProgramConstantsFromVector(type:String, firstRegister:int, data:Vector.<Number>, numRegisters:int = -1):void;
		function get modelViewProjection():Matrix3D;
		function set modelViewProjection(value:Matrix3D):void;
		function set cameraMatrix(value:Matrix3D):void;
		function get cameraMatrix():Matrix3D;
		function addLight(light:IMLight):void;
		function get ambiantLight():Vector.<Number>;
		function set ambiantLight(value:Vector.<Number>):void;
		function setSaticConstants():void;
		function destroy():void;
	}
	
}